#!/usr/bin/perl

# the input file has one line per example, with the score first and then
# the label.
#
# the output the area under the ROC curve.

$| = 1;

if (scalar(@ARGV) < 1) {
    die "Usage: $0 <input_file> [ <output_file> ]";}
$input_file = shift @ARGV;
$output_file = shift @ARGV;

$tp = 0;
$fp = 0;
$total_under = 0;
if ($output_file) {
    open OUTPUT, ">$output_file";}
else {
    open OUTPUT, ">-";}

open LABELS_SORTED_BY_SCORES, "$input_file";
while (<LABELS_SORTED_BY_SCORES>) {
    chomp;
    if ($_ == 1) {
	$tp++;}
    else {
	$fp++;
	$total_under += $tp;}}
printf OUTPUT "Area under ROC curve: %.6f\n", $total_under/($fp*$tp);
    
