#!perl

# takes as input a dataset with class labels in the last column
# ignores labels, calculates principal component of covariance matrix
# sorts examples by projection on this direction
# outputs labels
# outputs file with examples, with scores appended
#

$DEBUG = 1;
use Math::MatrixReal;

if (scalar(@ARGV) < 3) {
    die "Usage: $0 <prefix> <num_features> <label_file> [ <sorted_examples> ]";}
$prefix = shift @ARGV;
$n = shift @ARGV;
$label_file = shift @ARGV;
$sorted_examples_file = shift @ARGV;

$num_examples = `cat $prefix.data | wc -l`;

open DATA, "$prefix.data";
for($i = 0; $i < $n; $i++) {
    $accum[$i] = 0;}

while(<DATA>) {
    @example = split(" ");
    for($i = 0; $i < $n; $i++) {
	if (!($examples[$t][$i] eq "?")) {
	    $accum[$i] = $example[$i];}}}
close DATA;

for($i = 0; $i < $n; $i++) {
    $mean[$i] = $accum[$i]/$num_examples;}

$" = ",";
print "means: (@mean)\n";

undef @accum;
for($i = 0; $i < $n; $i++) {
  for($j = 0; $j < $n; $j++) {
    $accum[$i][$j] = 0;}}

open DATA, "$prefix.data";
while(<DATA>) {
  @example = split(" ");
  for($i = 0; $i < $n; $i++) {
    if ($example[$i] eq "?") {
      $example[$i] = 0;}}
      
  for($i = 0; $i < $n; $i++) {
    for($j = 0; $j < $n; $j++) {
	$accum[$i][$j]
	    += ($example[$i]-$mean[$i])
	    * ($example[$j]-$mean[$j]);}}}
close DATA;

for($i = 0; $i < $n; $i++) {
  for($j = 0; $j < $n; $j++) {
    $covariance[$i][$j] = $accum[$i][$j]/$num_examples;}}
	
$cov = Math::MatrixReal->new_from_rows(\@covariance);

if ($DEBUG) {
    print "\n\n";

    print $corr;}

($eigenvalues,$eigenvectors) = $cov->sym_diagonalize(); 

if ($DEBUG) {
    print "\neigenvalues\n";
    print $eigenvalues;

    print "\neigenvectors\n";
    print $eigenvectors;}

$max_index = 1;
for($i = 2; $i <= $n; $i++) {
    if ($eigenvalues->element($i,1) > $eigenvalues->element($max_index,1)) {
	$max_index = $i;}}

$weights_column = $eigenvectors->column($max_index);
$weights_string = "$weights_column";
$weights_string =~ s/\[ //sg;
$weights_string =~ s/ \]//sg;
@weights = split(/\s+/s,$weights_string);
shift @weights;
$" = ",";
print "\nweights: (@weights)\n";

# take direction closer to upper-left octant
$accum = 0;
for($i = 0; $i < $n; $i++) {
    $accum += $weights[$i];}
if ($accum < 0) {
    for($i = 0;$i < $n; $i++) {
	$weights[$i] = -$weights[$i];}}

open DATA, "$prefix.data";
open OUTPUT, "| sort -rn +1 +2 | awk '{print \$1}' > $label_file";
while (<DATA>) {
  @example = split(" ");
  $label = pop @example;
  if (!($label =~ /^\?/)) {
    $accum = 0;
    for($i = 0; $i < $n; $i++) {
      if (!($example[$i] eq "?")) {
	$accum += $weights[$i]*$example[$i];}}

    # for breaking ties
    $r = rand();
    print OUTPUT "$label $accum $r\n";}}
close DATA;
close OUTPUT;

print "\n";
system "perl auc.pl $label_file";

