#!perl

# generates data in which 
#     - attributes are conditionally independent given class label
#     - class 0 items 
#          - have variables distributed according to exponentials, cut off at 1
#          - parameters chosen uniformly between 0 and mu_max
#     - class 1 items uniform on [0,1]

$mu_max = 0.5;
$m = 100000;
$n = 5;
$PrYis1 = 0.01;
$tiny = 0.0000001;

if (scalar(@ARGV) == 0) {
  die "Usage: $0 <output_prefix> [ <variable 1> <value1> ] ...";}
$output_prefix = shift @ARGV;
while (scalar(@ARGV) > 1) {
  $variable_name = shift @ARGV;
  $value = shift @ARGV;
  ${$variable_name} = $value;}

for($i = 0; $i < $n; $i++) {
    push @mu, $tiny + rand($mu_max);}

open DATA, ">$output_prefix.data";
$" = " ";
for($t = 0; $t < $m; $t++) {

  if (rand(1) < $PrYis1) {
    # Y is 1
    for ($i = 0; $i < $n; $i++) {
	printf DATA "%.5f ", rand(1);}
    print DATA "1";
    print DATA "\n";}
  else {
    # Y is 0
    for ($i = 0; $i < $n; $i++) {
      do {
	$percentile = rand(1);}
	while($percentile < $tiny 
	      || -log($percentile)*$mu[$i] > 1);
      printf DATA "%.5f ", -log($percentile)*$mu[$i];}
    print DATA "0";
    print DATA "\n";}}
close DATA;

open NAMES, ">$output_prefix.names";
for($i = 0; $i < $n; $i++) {
  print NAMES "X$i\n";}
print NAMES "Y\n";
close NAMES;

open NOTES, ">$output_prefix.notes";
print NOTES "Generated using research/peer/gen_data.pl\n";
$" = ",";
print NOTES "\$mu_max = $mu_max\n";
print NOTES "\@mu = (@mu)\n";
print NOTES "Pr(Y=1) = $PrYis1\n";
print NOTES "\$m = $m\n";
print NOTES "\$n = $n\n";
close NOTES;

