#!/usr/bin/perl

# this code is for evaluation only.  it assumes that the first n
# positions are attributes, and the next is the label.  it outputs
# the labels in sorted order, as well as the examples with the
# scores appended

# IT ASSUMES THAT THE EXAMPLES ARE SEPARATED BY WHITE SPACE, NOT COMMAS
#

$DEBUG = 1;
$| = 1;
$max_iterations = 20;
$min_examples = 100;


if (scalar(@ARGV) < 3) {
    die "Usage: $0 <prefix> <num_features> <label_file> <example_file> -switch1 val1 ...";}

$prefix = shift @ARGV;
$n = shift @ARGV;
$label_file = shift @ARGV;
$example_file = shift @ARGV;

$m = `cat $prefix.data | wc -l`;

while(scalar(@ARGV) > 0) {
  if (scalar(@ARGV) == 1 || !($ARGV[0] =~ /^\-/)) {
    die "Usage: $0 <prefix> <score_file> -switch1 val1 ...";}

  $varname = shift @ARGV;
  $varname =~ s/^\-//;
  $val = shift @ARGV;
  ${$varname} = $val;}

if (!(-e "temp") || !(-d "temp")) {
  system "mkdir temp";}


if (!(-e "temp") || !(-d "temp")) {
    system "mkdir temp";}
$temp_prefix = "temp/" . int(rand(100000000000));
$old_assignment_file = "$temp_prefix.old_assignments";
$assignment_file = "$temp_prefix.assignments";

# $temp_prefix = "test";

system "sed 's/?/0.0/g' $prefix.data > $temp_prefix.data";
system "awk '\$NF != \"?\"' $prefix.data | sed 's/?/0.0/g' > $temp_prefix.test";
for($i = 0; $i < $n; $i++) {
  print "Preprocessing variable $i\n";
  $i_plus_1 = $i + 1;
  system "awk '{ print \$$i_plus_1 }' $temp_prefix.data | sort -nr > $temp_prefix.data$i";

  $this_bin = 0;
  $this_bin_end_index = $min_examples;
  if ($this_bin_end_index > $m-1) {
    $this_bin_end_index = $m-1;}
  $t = 0;
  open VALS, "$temp_prefix.data$i";
  while ($t < $m && ($this_val = <VALS>)) {
    if ($t == $this_bin_end_index) {
      $left_val = $this_val;
      $t++;
      while ($t < $m && (($this_val = <VALS>) == $left_val)) {
	$t++;}
      if ($t < $m) {
	$bin_end[$i][$this_bin] = ($left_val + $this_val)/2.0;}
      else {
	$bin_end[$i][$this_bin] = 0;}

      $this_bin_end_index *= 2;
      $this_bin++;}
    $t++;}
  close VALS;}

print "Discretizing variables\n";
open DATA, "$temp_prefix.data";
open DISC, ">${temp_prefix}disc.data";
$, = " ";
while (<DATA>) {
  chomp;
  @example = split(" ",$_);
  $label = pop @example;
  @discretized = ();
  for($i = 0; $i < $n; $i++) {
    $this_bin = 0;
    while ($this_bin < scalar(@{$bin_end[$i]})
	   && $example[$i] < $bin_end[$i][$this_bin]) {
      $this_bin++;}
    push @discretized, $this_bin;}
  push @discretized, $label;
  print DISC @discretized;
  print DISC "\n";}
close DATA;
close DISC;

open TEST, "$temp_prefix.test";
open TESTDISC, ">${temp_prefix}disc.test";

$, = " ";
while (<TEST>) {
  chomp;
  @example = split(" ",$_);
  $label = pop @example;
  @discretized = ();
  for($i = 0; $i < $n; $i++) {
    $this_bin = 0;
    while ($this_bin < scalar(@{$bin_end[$i]})
	   && $example[$i] < $bin_end[$i][$this_bin]) {
      $this_bin++;}
    push @discretized, $this_bin;}
  push @discretized, $label;
  print TESTDISC @discretized;
  print TESTDISC "\n";}
close TEST;
close TESTDISC;

new_params();

open DISC, "${temp_prefix}disc.data";
open ASSIGNMENTS, ">$assignment_file";
while (<DISC>) {
  chomp;
  @example = split(" ");

  while (scalar(@example) > $n) {
    pop @example;}
  $, = " ";

  $logPrXandYis0 = log(1-$PrYis1);
  for($i = 0; $i < $n; $i++) {
    $logPrXandYis0 += log($PrXiGivenYis0[$i][$example[$i]]);}

  $logPrXandYis1 = log($PrYis1);
  for($i = 0; $i < $n; $i++) {
    $logPrXandYis1 += log($PrXiGivenYis1[$i][$example[$i]]);}

  $PrYis1GivenX = 1.0/(1.0+exp($logPrXandYis0-$logPrXandYis1));

  print ASSIGNMENTS "$PrYis1GivenX";
  print ASSIGNMENTS "\n";}
close DISC;
close ASSIGNMENTS;

for($iter = 0; 
    $iter < $max_iterations 
    && (!defined($changes) || $changes >= 1);
    $iter++) {

  print "\n------------------------------------\n";
  print "Iteration $iter\n";

  # initialize counts
  for($i = 0; $i < $n; $i++) {
    for($bin = 0; $bin < scalar(@{$PrXiGivenYis1[$i]}); $bin++) {
      $countXiWhenYis0[$i][$bin] = 1;
      $countXiWhenYis1[$i][$bin] = 1;}}

  open ASSIGNMENTS, "$assignment_file";
  open DISC, "${temp_prefix}disc.data";
  while(<DISC>) {
    chomp;
    @example = split(" ");

    $assignment = <ASSIGNMENTS>;
    chomp($assignment);
    for($i = 0; $i < $n; $i++) {
      $countXiWhenYis0[$i][$example[$i]] += (1 - $assignment);
      $countXiWhenYis1[$i][$example[$i]] += $assignment;}}
  close ASSIGNMENTS;
  close DISC;

  for($i = 0; $i < $n; $i++) {
    $zero_weight = 0;
    for($bin = 0; $bin < scalar(@{$countXiWhenYis0[$i]}); $bin++) {
      $zero_weight += $countXiWhenYis0[$i][$bin];}
    for($bin = 0; $bin < scalar(@{$countXiWhenYis0[$i]}); $bin++) {
      $PrXiGivenYis0[$i][$bin] = $countXiWhenYis0[$i][$bin]/$zero_weight;}
    $one_weight = 0;
    for($bin = 0; $bin < scalar(@{$countXiWhenYis1[$i]}); $bin++) {
      $one_weight += $countXiWhenYis1[$i][$bin];}
    for($bin = 0; $bin < scalar(@{$countXiWhenYis1[$i]}); $bin++) {
      $PrXiGivenYis1[$i][$bin] = $countXiWhenYis1[$i][$bin]/$one_weight;}}
  $PrYis1 = $one_weight/($one_weight+$zero_weight);
    

  print "\nParameters:\n";
  $, = ", ";
  $# = "%.6g";
  print "PrYis1 = $PrYis1\n";
  print "Conditional probabilities:\n---------------------\n";
  for($i = 0; $i < $n; $i++) {
    print "Pr(Xi=.|Y=0) = ";
    print @{$PrXiGivenYis0[$i]};
    print "\n";
    print "Pr(Xi=.|Y=1) = ";
    print @{$PrXiGivenYis1[$i]};
    print "\n";
    print "\n";}

  system "mv $assignment_file $old_assignment_file";

  $changes = 0;
  open OLD, "$old_assignment_file";
  open DISC, "${temp_prefix}disc.data";
  open ASSIGNMENTS, ">$assignment_file";
  while (<DISC>) {
    chomp;
    @example = split(" ");

    $old_assignment = <OLD>;
    chomp($old_assignment);
    $, = " ";

    $logPrXandYis0 = log(1-$PrYis1);
    for($i = 0; $i < $n; $i++) {
      $logPrXandYis0 += log($PrXiGivenYis0[$i][$example[$i]]);}

    $logPrXandYis1 = log($PrYis1);
    for($i = 0; $i < $n; $i++) {
      $logPrXandYis1 += log($PrXiGivenYis1[$i][$example[$i]]);}

    $PrYis1GivenX = 1.0/(1.0+exp($logPrXandYis0-$logPrXandYis1));

    print ASSIGNMENTS "$PrYis1GivenX";
    print ASSIGNMENTS "\n";
      
    if ($PrYis1GivenX > $old_assignment) {
      $changes += $PrYis1GivenX - $old_assignment;}
    else {
      $changes += $old_assignment - $PrYis1GivenX;}}
  close OLD;
  close ASSIGNMENTS;
  close DISC;

  print "\nChanges: $changes\n";}

# which cluster is the 1 cluster?  the one with the bigger values of
# the variables
#
# note that bin 0 is the bin with the largest value of each variable
$evidence_for_cluster_1 = 0;
for($i = 0; $i < $n; $i++) {
  $evidence_for_cluster_1 += log($PrXiGivenYis1[$i][0]);
  $evidence_for_cluster_1 -= log($PrXiGivenYis0[$i][0]);}

open TESTDISC, "${temp_prefix}disc.test";
open OUTPUT, "| sort -rn +1 +2 | awk '{print \$1}' > $label_file";
while (<TESTDISC>) {
  @example = split(" ");

  $label = pop @example;
  $logPrXandYis0 = log(1-$PrYis1);
  for($i = 0; $i < $n; $i++) {
    $logPrXandYis0 += log($PrXiGivenYis0[$i][$example[$i]]);}

  $logPrXandYis1 = log($PrYis1);
  for($i = 0; $i < $n; $i++) {
    $logPrXandYis1 += log($PrXiGivenYis1[$i][$example[$i]]);}
  
  $score = $evidence_for_cluster_1*($logPrXandYis1-$logPrXandYis0);
  
  # for breaking ties
  $r = rand();
  print OUTPUT "$label $score $r\n";}
close TESTDISC;
close OUTPUT;

print "\n";
system "perl auc.pl $label_file";

sub new_params {

  my $x_val;
  my $i;
  my $y;
  my $Z;
  my $this_param;

  for($i = 0; $i < $n; $i++) {
    $Z = 0;
    for($x_val = 0; $x_val <= scalar(@{$bin_end[$i]}); $x_val++) {
      $this_param = rand();
      $PrXiGivenYis0[$i][$x_val] = $this_param;
      $Z += $this_param;}
    for($x_val = 0; $x_val <= scalar(@{$bin_end[$i]}); $x_val++) {
      $PrXiGivenYis0[$i][$x_val]/=$Z;}

    $Z = 0;
    for($x_val = 0; $x_val <= scalar(@{$bin_end[$i]}); $x_val++) {
      $this_param = rand();
      $PrXiGivenYis1[$i][$x_val] = $this_param;
      $Z += $this_param;}
    for($x_val = 0; $x_val <= scalar(@{$bin_end[$i]}); $x_val++) {
      $PrXiGivenYis1[$i][$x_val]/=$Z;}}

  $PrYis1 = 0.5;}
  

system "rm $old_assignment_file";
system "rm $assignment_file";
