#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


/*
# this code is for evaluation only.  it assumes that the first n
# positions are attributes, and the next is the label.  it outputs
# the labels in sorted order, as well as the examples with the
# scores appended
#

****************
the data is required to be in a somewhat nonstandard format
in addition to 

	prefix.data, 

there also should be files

	prefix.data0, prefix.data1, prefix.data2,...

containing the values of the individual variables, in sorted order, with
no missing values in the variables.

also, 

	prefix.data

should NOT be in the usual comma-separated form, instead, it should be
white-space separated
****************
*/

/* the constant needed for a 95% confidence interval */
#define c 1.96
double beta_factor=2;

void quicksort(double *a,int low,int high) 
{
  double temp;
  double pivot;
  int pivoti;
  int i,j;

  /*  printf("low = %1d, high = %1d\n",low,high); */
  if(low < high) {
    pivoti = low + (random() % (high - low + 1));
    pivot = a[pivoti];
    temp = a[high];
    a[high] = a[pivoti];
    a[pivoti] = temp;
    for(i = low, j = high - 1; i <= j;) {
      while(i < high && a[i] < pivot)
	i++;
      while(j >= low && pivot <= a[j])
	j--;
      if(i < j) {
	temp = a[i];
	a[i] = a[j];
	a[j] = temp;}}
    temp = a[high];
    a[high] = a[i];
    a[i] = temp;
      
    quicksort(a, low, i-1);    
    quicksort(a, i+1, high);}
}

main(int argc, char **argv) {
  char train_file_name[80],label_file_name[80],fullout_file_name[80];
  char test_file_name[80],attr_trace_file_name[80],string[200];
  double *possible_thetas,*score,**log_ratio,**piece;
  double *attr_trace,*largest,*example,**beta,**threshold,**theta,***p;
  double **boundary;
  double start_beta,smallest_condprob,left_est,right_est,this_score;
  double PrYis1, worst_too_small, worst_too_big, how_bad;
  double PrGeqGivenYis1,PrGeqGivenYis0,last_ratio,current_ratio;
  double smallest_in_bin, largest_in_bin, fraction_across_bin;
  double this_feature;
  FILE *fatt,*ftrain,*ftest,*fexamples;
  int *num_knots,**count;
  int i,j,k,n,num_training,num_test,round,r,s,t,ell,bin;
  int num_rounds;
  int which_theta,found,middle;
  int b;

  if (argc < 5) {
    printf("Usage: peer_rank <prefix> <num_training> <num_test> <num_features>");
    exit(0);}

  strcpy(train_file_name,argv[1]);
  strcat(train_file_name, ".data");
  num_training = atoi(argv[2]);
  num_test = atoi(argv[3]);
  n = atoi(argv[4]);
  strcpy(fullout_file_name,argv[1]);
  strcat(fullout_file_name,".output");
  strcpy(test_file_name,argv[1]);
  strcat(test_file_name, ".test");

  num_rounds = (int)(log(((double)num_training))/log(beta_factor));

  printf("training data in %s, size = %1d\n",train_file_name,num_training);
  printf("test data in %s, size = %1d\n",test_file_name,num_test);
  printf("n = %1d\n", n);
  printf("allocating space\n");
  fflush(stdout);
  attr_trace = (double *)malloc(num_training*sizeof(double));
  largest = (double *)malloc(n*sizeof(double));
  num_knots = (int *)malloc(n*sizeof(int));
  example = (double *)malloc(n*sizeof(double));
  possible_thetas = (double *)malloc(((n-1)*(n-2)/2)*sizeof(double));

  beta = (double **)malloc(num_rounds*sizeof(double *));
  for(r = 0; r < num_rounds;r++) {
    beta[r] = (double *)malloc(n*sizeof(double));}

  threshold = (double **)malloc(n*sizeof(double *));
  theta = (double **)malloc(n*sizeof(double *));
  log_ratio = (double **)malloc(n*sizeof(double *));
  piece = (double **)malloc(n*sizeof(double *));
  boundary = (double **)malloc(n*sizeof(double *));
  for(i = 0; i<n; i++) {
    threshold[i] = (double *)malloc(num_rounds*sizeof(double));
    theta[i] = (double *)malloc(num_rounds*sizeof(double));
    log_ratio[i] = (double *)malloc(num_rounds*sizeof(double));
    piece[i] = (double *)malloc(num_rounds*sizeof(double));
    boundary[i] = (double *)malloc(num_rounds*sizeof(double));}

  count = (int **)malloc(n*sizeof(int *));
  for(i = 0; i<n; i++) {
    count[i] = (int *)malloc(n*sizeof(int));}

  p = (double ***)malloc(num_rounds*sizeof(double **));
  for(r = 0; r < num_rounds; r++) {
    p[r] = (double **)malloc(n*sizeof(double *));
    for(i = 0; i < n; i++) {
      p[r][i] = (double *)malloc(n*sizeof(double));}}

  printf("calculating thresholds\n");
  fflush(stdout);
  for(i = 0; i < n; i++) {
    printf("  i = %1d\n",i);
    fflush(stdout);
    round = 0;
    strcpy(attr_trace_file_name,train_file_name);
    sprintf(string,"%1d",i);
    strcat(attr_trace_file_name,string);
    fatt = fopen(attr_trace_file_name,"r");
    for(t = 0; t < num_training; t++) {
      if (t && !(t % 100000)) {
	      printf("    t = %1d\n",t);
	      fflush(stdout);} 
      fscanf(fatt,"%lf",&(attr_trace[t]));}

    largest[i] = attr_trace[0];
    printf("  largest[%1d] = %.6f\n",i,largest[i]);
    fflush(stdout);

    for(start_beta = 1.0/num_training, round = 0; 
	round < num_rounds;
	start_beta *= beta_factor, round++) {

      s = (int)(start_beta*num_training);
      /* put threshold between two values of the variable */
      if (s == 0) {
	s = 1;}
      while (s < num_training
	     && attr_trace[s] == attr_trace[s-1]) {
	s++;}

      /* if got to bottom, move up until place between values is found */
      if (s == num_training) {
	s = (int)(start_beta*num_training);
	
	while (s > 0
	       && attr_trace[s] == attr_trace[s-1]) {
	  s--;}
	if (s == 0) {
	  fprintf(stderr, "Variable %1d seems to take only one value\n",i);
	  exit(0);}}
      threshold[i][round] = (attr_trace[s] + attr_trace[s-1])/2.0;
      beta[round][i] = ((double)s)/((double)num_training);
      printf("    threshold[%1d][%1d] = %.6f, ", i, round, 
	     threshold[i][round]);
      printf("    beta[%1d][%1d] = %.6f\n", round, i, 
	     beta[round][i]);
      fflush(stdout);}
    fclose(fatt);}
  free(attr_trace);

  for(start_beta = 1.0/num_training,round=0; 
      round < num_rounds;
      start_beta *= beta_factor,round++) {
    printf("round %1d\n", round);
    fflush(stdout);

    for(i = 0; i < n; i++) {
      for(j = i + 1;j < n; j++) {
	count[i][j] = 0;}}

    ftrain = fopen(train_file_name,"r");
    for(t = 0; t < num_training; t++) {
      if (!(t % 100000)) {
	printf("  t = %1d\n",t);
	fflush(stdout);} 
      for(i = 0; i < n; i++) {
	fscanf(ftrain,"%lf",&(example[i]));}
      
      for(i = 0; i < n; i++) {
	for(j = i + 1;j < n; j++) {
	  if (example[i] > threshold[i][round]
	      && example[j] > threshold[j][round]) {
	    count[i][j]++;}}}

      /* read off rest of line, including label */
      while((b = fgetc(ftrain)) != '\n');}
    fclose(ftrain);

    for(i = 0; i < n; i++) {
      for(j = i + 1;j < n; j++) {
	p[round][i][j] = ((double)count[i][j])/((double)num_training);
	p[round][j][i] = p[round][i][j];
	printf("    p[%1d][%1d][%1d] = %.6f\n",round,i,j,p[round][i][j]);
	fflush(stdout);}}}
    
  smallest_condprob = 1.0/((double)num_training);
  left_est = 0;
  right_est = 0.5;
  while (right_est - left_est > 1.0/((double)num_training)) {
    PrYis1 = (right_est + left_est)/2.0;
    printf("\n----------------------------------------------------------\n");
    printf("right_est = %.6f, left_est = %.6f\n",right_est,left_est);
    printf("Trying Pr(Y=1) = %.6f\n",PrYis1);
    fflush(stdout);
    worst_too_small = -1.0;
    worst_too_big = -1.0;
    for(round = 0; round < num_rounds; round++) {
      printf("round %1d\n----------\n", round);
      for(i = 0; i < n; i++) {
	  
	which_theta = 0;
	for(j = 0; j < n; j++) {
	  for(k = j+1; k < n; k++) {
	    if ((i != j) 
		&& (i != k)
		&& p[round][i][j] > beta[round][i]*beta[round][j]
		&& p[round][i][k] > beta[round][i]*beta[round][k]
		&& p[round][j][k] > beta[round][j]*beta[round][k]) {

	      possible_thetas[which_theta] =
		beta[round][i] 
		+ sqrt(exp(log(1-PrYis1)
			   -log(PrYis1)
			   +log(p[round][i][j]
				-beta[round][i]
				*beta[round][j])
			   +log(p[round][i][k]
				-beta[round][i]
				*beta[round][k])
			   -log(p[round][j][k]
				+c*sqrt(p[round][j][k]
					*(1 - p[round][j][k])/
					((double)num_training))
				-beta[round][j]
				*beta[round][k])));
	      which_theta++;}}}

	if (which_theta > 0) {
	  quicksort(possible_thetas,0,which_theta-1);
	  theta[i][round] = possible_thetas[which_theta/2];}
	else {
	  theta[i][round] = beta[round][i];}

	how_bad 
	  = smallest_condprob
	  - ((beta[round][i] - theta[i][round]*PrYis1)/(1-PrYis1));
	if (how_bad > worst_too_big) {
	  worst_too_big = how_bad;}

	how_bad
	  = theta[i][round] - (1 - smallest_condprob);
	if (how_bad > worst_too_small) {
	  worst_too_small = how_bad;}

	if (theta[i][round] 
	    > ((beta[round][i] - smallest_condprob*(1-PrYis1))/PrYis1)) {
	  theta[i][round] 
	    = ((beta[round][i] - smallest_condprob*(1-PrYis1))/PrYis1);}
	if (theta[i][round] 
	    > (1 - smallest_condprob)) {
	  theta[i][round] 
	    = 1 - smallest_condprob;}

	printf("    Pr(X_%1d >= %.6f) ~ %16.6f\n", 
	       i, threshold[i][round], beta[round][i]);
	printf("    Pr(X_%1d >= %.6f | Y = 1) ~ %8.6f\n", 
	       i, threshold[i][round], theta[i][round]);
	printf("    Pr(X_%1d >= %.6f | Y = 0) ~ %8.6f\n\n", 
	       i, threshold[i][round], 
	       (beta[round][i] - PrYis1*theta[i][round])/(1 - PrYis1));}
      printf("\n\n");
      fflush(stdout);}
    printf("\nWorst consequence of Pr(Y=1) too big: %.6f\n",worst_too_big);
    printf("Worst consequence of Pr(Y=1) too small: %.6f\n", worst_too_small);
    fflush(stdout);
      
    if (worst_too_big > worst_too_small) {
      right_est = PrYis1;}
    else {
      left_est = PrYis1;}}

  printf("Using Pr(Y=1) = %.6f\n", PrYis1);
  
  printf("Computing ratios\n");
  fflush(stdout);
  for(i = 0; i < n; i++) {
   
    for(round = 0; round < num_rounds; round++) {
      PrGeqGivenYis1 = theta[i][round];
      PrGeqGivenYis0 
	= (beta[round][i] - PrYis1*theta[i][round])/(1 - PrYis1);
      
      if(PrGeqGivenYis1 < smallest_condprob) {
	PrGeqGivenYis1 = smallest_condprob;}
      if(PrGeqGivenYis1 > 1 - smallest_condprob) {
	PrGeqGivenYis1 = 1 - smallest_condprob;}
      if(PrGeqGivenYis0 < smallest_condprob) {
	PrGeqGivenYis0 = smallest_condprob;}
      if(PrGeqGivenYis0 > 1 - smallest_condprob) {
	PrGeqGivenYis0 = 1 - smallest_condprob;}
	
      log_ratio[i][round] = log(PrGeqGivenYis1/PrGeqGivenYis0);}}

  for(i = 0; i < n; i++) {
    for(r = 0; r < num_rounds; r++) {
      printf("%6.1f",log_ratio[i][r]);
      fflush(stdout);}
    printf("\n");}

  printf("\nMonotonizing\n");
  for(i = 0;i < n; i++) {

    last_ratio = log_ratio[i][num_rounds-1];
    for(r = num_rounds-1; r >= 0; r--) {
      if (log_ratio[i][r] < last_ratio) {
	log_ratio[i][r] = last_ratio;}
      last_ratio = log_ratio[i][r];}}
  
  for(i = 0; i < n; i++) {
    for(r = 0; r < num_rounds; r++) {
      printf("%6.1f",log_ratio[i][r]);}
    printf("\n");}

  printf("\nConsolidating\n");
  for(i = 0; i < n; i++) {
    num_knots[i] = 0;
    current_ratio = log_ratio[i][0];
    r = 0;

    while(r < num_rounds) {
      while(r < num_rounds
	    && (log_ratio[i][r] == current_ratio)) {
	r++;}
      boundary[i][num_knots[i]] = threshold[i][r-1];
      piece[i][num_knots[i]] = log_ratio[i][r-1];
      num_knots[i]++;
      if (r < num_rounds) {
	current_ratio = log_ratio[i][r];}}}

  for(i = 0; i < n; i++) {
    for(ell = 0; ell < num_knots[i]; ell++) {
      printf("%6.1f",piece[i][ell]);}
    printf("\n");}

  printf("\nComputing scores\n");

  ftest=fopen(test_file_name,"r");
  fexamples=fopen(fullout_file_name,"w");
  for(t = 0; t < num_test; t++){

    if (!(t % 100000)) {
      printf("  t = %1d\n",t);
      fflush(stdout);} 

    this_score = 0.0;

    for(i = 0; i < n; i++) {
      fscanf(ftest,"%lf",&this_feature);
    
      ell = 0;
      found = 0;
      while (ell < num_knots[i]
	     && this_feature < boundary[i][ell]) {
	ell++;}

      bin = ell;
      
      if (bin == num_knots[i]) {
	smallest_in_bin = 0.0;}
      else {
	smallest_in_bin = boundary[i][bin];}

      if (bin == 0) {
	largest_in_bin = largest[i];}
      else {
	largest_in_bin = boundary[i][bin-1];}

      fraction_across_bin 
	= (this_feature - smallest_in_bin)/
	  (largest_in_bin - smallest_in_bin);

      if (bin == num_knots[i]) {
	this_score 
	  += ((1 - 0.5*fraction_across_bin)*piece[i][bin] 
	      + (0.5*fraction_across_bin)*piece[i][bin-1]);}
      else {
	if (bin == 0) {
	  this_score 
	    += ((0.5 + 0.5*fraction_across_bin)*piece[i][bin] 
		+ (0.5 - 0.5*fraction_across_bin)*piece[i][bin+1]);}
	else {
	  this_score
	    += (0.5*piece[i][bin] 
	        + 0.5*(1 - fraction_across_bin)*piece[i][bin+1]
		+ 0.5*fraction_across_bin*piece[i][bin-1]);}}
      fprintf(fexamples, "%lf ", this_feature);}
    
    /* label */
    fscanf(ftest,"%s",string);

    /* eat up rest of line */
    while((b = fgetc(ftest)) != EOF && (b != '\n'));

    if (b == EOF) {
      fprintf(stderr, "Test file not as big as expected\n");}

    fprintf(fexamples,"%s ",string);

    
    fprintf(fexamples,"%.10f\n", this_score);}

  fclose(fexamples);
  fclose(ftest);
  }
