#!/usr/bin/perl

$| = 1;

open ALL_RESULTS, ">all_results.txt";

for ($i = 0; $i < 100; $i++) {
    system "perl gen_data.pl synth";

    system "perl peer_rank.pl synth 5 synth_peer.labels synth_peer.examples";
    $auc = `perl auc.pl synth_peer.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	print "Peer AUC on synthetic dataset $i: $1\n";
	print ALL_RESULTS "Peer AUC on synthetic dataset $i: $1\n";
	$peer_accum += $1;}
    else {
	die "Unable to parse auc.pl's output";}

    system "perl eigen_rank.pl synth 5 synth_eigen.labels";
    $auc = `perl auc.pl synth_eigen.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	print "Eigen AUC on synthetic dataset $i: $1\n";
	print ALL_RESULTS "Eigen AUC on synthetic dataset $i: $1\n";
	$eigen_accum += $1;}
    else {
	die "Unable to parse auc.pl's output";}

    system "perl kmeans_rank.pl synth 5 synth_kmeans.labels synth_kmeans.examples";
    $auc = `perl auc.pl synth_kmeans.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	print "Kmeans AUC on synthetic dataset $i: $1\n";
	print ALL_RESULTS "Kmeans AUC on synthetic dataset $i: $1\n";
	$kmeans_accum += $1;}
    else {
	die "Unable to parse auc.pl's output";}

    system "perl nb_em_rank.pl synth 5 synth_nb_em.labels synth_nb_em.examples";
    $auc = `perl auc.pl synth_nb_em.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	print "Nb_Em_Missing AUC on synthetic dataset $i: $1\n";
	print ALL_RESULTS "Nb_Em_Missing AUC on synthetic dataset $i: $1\n";
	$nb_em_accum += $1;}
    else {
	die "Unable to parse auc.pl's output";}

    printf "Running average of peer AUC: %.6f\n", $peer_accum/(1 + $i);
    printf "Running average of eigen AUC: %.6f\n", $eigen_accum/(1 + $i);
    printf "Running average of kmeans AUC: %.6f\n", $kmeans_accum/(1 + $i);
    printf "Running average of NB_EM AUC: %.6f\n", $nb_em_accum/(1 + $i);
    print "\n";
    sleep 10;}
close ALL_RESULTS;

open FINAL, ">summary.txt";
printf "Peer average AUC: %.6f\n", $peer_accum/$i;
printf "Eigen average AUC: %.6f\n", $eigen_accum/$i;
printf "Kmeans average AUC: %.6f\n", $kmeans_accum/$i;
printf "EM average AUC: %.6f\n", $nb_em_accum/$i;
printf FINAL "Peer average synth AUC: %.6f\n", $peer_accum/$i;
printf FINAL "Eigen average synth AUC: %.6f\n", $eigen_accum/$i;
printf FINAL "Kmeans average synth AUC: %.6f\n", $kmeans_accum/$i;
printf FINAL "EM average AUC: %.6f\n", $nb_em_accum/$i;

system "perl peer_rank.pl protein_protein 5 pp_peer.labels pp_peer.examples";
$auc = `perl auc.pl pp_peer.labels`;
if ($auc =~ /Area under ROC curve: (.*)\n/s) {
  print "Peer AUC on protein-protein: $1\n";
  print FINAL "Peer AUC on protein-protein: $1\n";}
else {
  die "Unable to parse auc.pl's output";}

system "perl eigen_rank.pl protein_protein 5 pp_eigen.labels";
$auc = `perl auc.pl pp_eigen.labels`;
if ($auc =~ /Area under ROC curve: (.*)\n/s) {
    print "Eigen AUC on protein-protein: $1\n";
    print FINAL "Eigen AUC on protein-protein: $1\n";}
else {
    die "Unable to parse auc.pl's output";}

$nb_em_accum = 0;
for($i = 0; $i < 5; $i++) {
    system "perl nb_em_rank.pl protein_protein 5 pp_nb_em.labels";
    $auc = `perl auc.pl pp_nb_em.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	$nb_em_accum += $1;
	print "Nb_Em AUC on protein-protein: $1\n";
	printf "Running average: %.6f\n", $nb_em_accum/(1+$i);}
    else {
	die "Unable to parse auc.pl's output";}}
printf "Nb_Em average AUC on protein-protein: %.6f\n", $nb_em_accum/$i;
printf FINAL "Nb_Em average AUC on protein-protein: %.6f\n", $nb_em_accum/$i;

$kmeans_accum = 0;
for($i = 0; $i < 5; $i++) {
    system "perl kmeans_rank.pl protein_protein 5 pp_kmeans.labels";
    $auc = `perl auc.pl pp_kmeans.labels`;
    if ($auc =~ /Area under ROC curve: (.*)\n/s) {
	$kmeans_accum += $1;
	print "Kmeans AUC on protein-protein: $1\n";
	printf "Running average: %.6f\n", $kmeans_accum/(1+$i);}
    else {
	die "Unable to parse auc.pl's output";}}
printf "Kmeans average AUC on protein-protein: %.6f\n", $kmeans_accum/$i;
printf FINAL "Kmeans average AUC on protein-protein: %.6f\n", $kmeans_accum/$i;
close FINAL;

